{$appl MSpA}  // CreatorID
Program PlasmaARM(cmd);
{$i PalmARM.pas}
{$i Double.pas}

Var
  t: record  // This record is passed to the ARM code
       CosTbl: Array[0..255] of UInt8; // This is a table to contain Cos values
       b1,b2,b3,b4: UInt8; // These are the startup values
     end;
  Cmd: UInt16;
  N: Integer;
  WidthP,HeightP,DepthP: UInt32;
  WidthO,HeightO,DepthO: UInt32;
  EnableColorP: Boolean;
  EnableColorO: Boolean;
  Error: Err;

//Initialize some values and the screen mode
procedure Initialize;
Var
  i: Integer;
  d1,d2,d3: Double;
  s: String;
  m: DensityType;
begin
  // These are the startup values
  t.b1:=Random(100);
  t.b2:=Random(100);
  t.b3:=Random(100);
  t.b4:=Random(100);
  // Creates the Cos table for the calculations
  for i:=0 to 255 do
    begin
      ppIToD(d1,i);
      s:='3.14159';
      Str2Double(d3,s);
      dMul(d2,d1,d3);
      s:='128';
      Str2Double(d3,s);
      dDiv(d1,d2,d3);
      dCos(d2,d1);
      s:='64';
      Str2Double(d3,s);
      dMul(d1,d2,d3);
      s:='64';
      Str2Double(d3,s);
      dAdd(d2,d1,d3);
      d1:=d2;
      t.CosTbl[i]:=ppDToI(d1);
    end;
  // Save the current screen mode
  Error:=WinScreenMode(winScreenModeGet,WidthO,HeightO,DepthO,EnableColorO);
  // Sets the new screen mode (only 16 bits works)
  WidthP:= 160;
  HeightP:= 160;
  DepthP:=16;
  EnableColorP:= True;
  Error:=WinScreenMode(winScreenModeSet,WidthP,HeightP,DepthP,EnableColorP);
end;

// Restore the old screen mode befor quitting
procedure ResetScr;
begin
  Error:=WinScreenMode(winScreenModeSet,WidthO,HeightO,DepthO,EnableColorO);
end;

// The main routine. There shoul be nothing complex here...
begin
  if (cmd=0) and (ArmPresent) then
    begin
      Initialize;
      N:=NativeCall($61726d63,0,t);
      ResetScr;
    end;
end.
