{$armlet appl,MSpA,armc,0}
Program PlasmaARM;
{$i PalmARMAPI.pas}

Type
  PalType=Array[0..255] of UInt16; // This is the type for the color palette
  ScrType=array[0..319,0..319] of UInt16; // This will map the screen
                                          // Shlud be changed if a single density
                                          // display is used (159 instead of 319)
  BufType=^ScrType; // And this is the pointer to the screen
    
Var
  t: record // This is the record passe from the 68K code
       CosTbl: Array[0..255] of UInt8;
       b1,b2,b3,b4: UInt8;
     end;

// This create the color palette for the plasma effect
Procedure InitColors(var Palet:PalType);
Var
  r,g,b,v: Uint16;
  i: UInt8;
begin
  for i:=0 to 63 do
    begin
      r:=0;
      g:=i*4;
      b:=255;
      Palet[i]:=((r and $f8) shl 8)+((g and $fc) shl 3)+((b and $f8) shr 3);
      r:=i*4;
      g:=255;
      b:=255-i*4;
      Palet[i+64]:=((r and $f8) shl 8)+((g and $fc) shl 3)+((b and $f8) shr 3);
      r:=255;
      g:=255-i*4;
      b:=0;
      Palet[i+128]:=((r and $f8) shl 8)+((g and $fc) shl 3)+((b and $f8) shr 3);
      r:=255-i*4;
      g:=0;
      b:=i*4;
      Palet[i+192]:=((r and $f8) shl 8)+((g and $fc) shl 3)+((b and $f8) shr 3);
    end;
end;

// The main routine.
// Draws the screen, gets the events and return to the 68K code when needed
// This routin works ONLY for double density screens. If you like to use it on a
// single density device you should change the ScrType definition and the
// lines where the points are drawn on the screen
procedure Drawing;
label 1;
var
  Palet: PalType;
  bits: BufType;
  i:integer;
  x,y,x1,y1,x2,y2: Integer;
  a1,a2,a3,a4,b: UInt8;
  e: EventType;
begin
  InitColors(Palet);
  // Now we gretrieve the screen address
  bits:=BmpGetBits(WinGetBitmap(WinGetDisplayWindow));
1: // Here starts the main cycle
  a1:=t.b1;
  a2:=t.b2;
  y1:=0;
  for y:=0 to 159 do
    begin
      a3:=t.b3;
      a4:=t.b4;
      x1:=0;
      for x:=0 to 159 do
        begin
          b:=t.CosTbl[a1]+t.CosTbl[a2]+t.CosTbl[a3]+t.CosTbl[a4];
          // These lines will draw a 2x2 box on the screen
          // To change for single display keep only the first
          // line and remove the "shl 1" from both x and y
          bits^[x shl 1,y shl 1]:=Palet[b];
          bits^[(x shl 1)+1,y shl 1]:=Palet[b];
          bits^[x shl 1,(y shl 1)+1]:=Palet[b];
          bits^[(x shl 1)+1,(y shl 1)+1]:=Palet[b];
          // End plotting
          a3:=a3+1;
          a4:=a4+2;
        end;
      a1:=a1+2;
      a2:=a2+1;
    end;
  t.b1:=t.b1+2;
  t.b2:=t.b2-3;
  t.b3:=t.b3-2;
  t.b4:=t.b4+4;
  // Now checks the event
  EvtGetEvent(e,0);
  SysHandleEvent(e);
  // If there is no request to stop the program then do the next frame
  if e.eType<>appStopEvent then goto 1;
end;

begin
  Drawing;
end.
